/***********************************************************
 * le serveur lit l'entre standard, envoie vers un fils,
 * attend une reponse de fils et affiche. Tout en mode non  
 * bloquant
 **********************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/wait.h>


#define TAMPON_TAILLE 1024
int main(void){
  char tin[TAMPON_TAILLE];
  char tout[TAMPON_TAILLE];

  ssize_t i;
  int pid,k;
  int in=STDIN_FILENO;
  int pf[2];
  int fp[2];

  if(  fcntl(in,F_SETFL,O_NONBLOCK) == -1 ){
    perror("nonblock");
    exit(EXIT_FAILURE);
  }

  if( pipe(pf) < 0 ){
    perror("creation tube");
    exit(EXIT_FAILURE);
  }
  if( pipe(fp) < 0 ){
    perror("creation tube");
    exit(EXIT_FAILURE);
  }

  pid=fork();
  if(pid < 0){
    perror("fork");
    exit(EXIT_FAILURE);
  }
  else if( pid == 0 ){/*client*/
    close(pf[1]);
    close(fp[0]);
    dup2(pf[0],STDIN_FILENO);
    close(pf[0]);
    dup2(fp[1],STDOUT_FILENO);
    close(fp[1]);
    execlp("client","client",(char *)NULL);
    perror("exec");
    exit(EXIT_FAILURE);
  }

  /*serveur*/

  close(pf[0]);
  close(fp[1]);
  /*
  if(  fcntl(pf[1],F_SETFL,O_NONBLOCK) == -1 ){
    perror("nonblock");
    exit(EXIT_FAILURE);
  }
  */
  if(  fcntl(fp[0],F_SETFL,O_NONBLOCK) == -1 ){
    perror("nonblock");
    exit(EXIT_FAILURE);
  }

  for( ;; ){
    /*read standard input*/
    i = read(in,tin,TAMPON_TAILLE);
    if( i < 0 && errno != EAGAIN ){
      perror("read line");
      close(pf[1]);
      close(fp[0]);
      exit(EXIT_FAILURE);
    }
    else if( i == 0 ){
      close( pf[1] );
      wait(NULL);
      close( fp[0] );
      exit(EXIT_SUCCESS);
    }
    else if( i > 0 ){
      k = write(pf[1],tin,i);
      if( k < 0 ){
	perror("write");
	exit(EXIT_FAILURE);
      }
    }
    /*read client*/
    k = read(fp[0],tout,1);
    if( k < 0 && errno != EAGAIN ){
      perror("read");
      exit(EXIT_FAILURE);
    }
    else if( k == 0 ){
      wait(NULL);
      exit(EXIT_FAILURE);
    }
    else if( k < 0 && errno == EAGAIN ){
      continue;
    }
    else if( k > 0 ){
      tout[k]='\0';
      printf("%s",tout);
    }
    /*    sleep(2);*/
  } 

  return EXIT_SUCCESS;
}
